
--this bloom function is used as a backup for where i couldn't really think of bloom functions for weapons
--it fades the opacity more the higher the bloom is
local universal_alpha_fade_bloom_function = function(index,bitmap,data)
	local crosshair_data = data.crosshair_data
	local part_data = crosshair_data.parts[index]
	local bloom = 1 - (data.bloom * (crosshair_data.bloom_mul or 1))
--			local scale = (data.scale or 1) * (part_data.scale or 1)
--			bitmap:set_size(scale * bloom * part_data.w,scale * bloom * part_data.h)
	bitmap:set_alpha(bloom * (part_data.alpha or 1))
--			bitmap:set_center(data.panel_w/2,data.panel_h/2)
end

local destiny_crosshairs_data = {
	destiny2_shotgun = {
		name = "Shotgun (Destiny 2)",
		--[[
		bloom_func = function(index,bitmap,data)
			local crosshair_data = data.crosshair_data
			local part_data = crosshair_data.parts[index]
			local bloom = data.bloom * (crosshair_data.bloom_mul or 1)
			local scale = (data.scale or 1) * (part_data.scale or 1)
			if index == 1 then 
				bitmap:set_alpha((1.25 - bloom) / 2)
			else
				local angle = part_data.rotation or 60
				local distance = scale * (part_data.distance or 10) * (bloom + 1)
				local c_x = data.panel_w/2
				local c_y = data.panel_h/2
				bitmap:set_alpha(bloom + 0.5)
				bitmap:set_center(c_x + (math.sin(angle) * distance),c_y - (math.cos(angle) * distance))
			end
		end,
		--]]
		parts = {
			{
				texture_path = "assets/destiny2_shotgun",
				w = 96,
				h = 96
			}
		}
	},
	destiny2_scoutrifle = {
		name = "Scout Rifle (Destiny 2)",
		bloom_func = function(index,bitmap,data)
			local crosshair_data = data.crosshair_data
			local part_data = crosshair_data.parts[index]
			local bloom = data.bloom * (crosshair_data.bloom_mul or 1)
			local scale = (data.scale or 1) * (part_data.scale or 1)
			if index == 1 then 
				bitmap:set_alpha(part_data.alpha * (1.5 - bloom) / 2)
			else
				local angle = part_data.angle or 0
				local distance = scale * (part_data.distance) * (bloom + 1)
				local inner_rect = bitmap:texture_width() - ((1 - bloom) * crosshair_data.inner_rect)
				bitmap:set_image(part_data.texture,0,0,inner_rect,inner_rect)
				local c_x = data.panel_w/2
				local c_y = data.panel_h/2
				--bitmap:set_alpha(bloom + 0.5)
				bitmap:set_center(c_x + (math.sin(angle) * distance),c_y - (math.cos(angle) * distance))
			end
		end,
		parts = {
			{
				texture_path = "assets/destiny2_scoutrifle_1",
				w = 32,
				h = 32,
				alpha = 0.75
			},
			{
				texture_path = "assets/destiny2_scoutrifle_2",
				texture_rect = {
					0,0,16,16
				},
				w = 6,
				h = 6,
				rotation = 0,
				angle = 315,
				distance = 8,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_scoutrifle_2",
				texture_rect = {
					0,0,16,16
				},
				w = 6,
				h = 6,
				rotation = 90,
				angle = 45,
				distance = 8,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_scoutrifle_2",
				texture_rect = {
					0,0,16,16
				},
				w = 6,
				h = 6,
				rotation = 180,
				angle = 135,
				distance = 8,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_scoutrifle_2",
				texture_rect = {
					0,0,16,16
				},
				w = 6,
				h = 6,
				rotation = 270,
				angle = 225,
				distance = 8,
				alpha = 1
			}
		},
		bloom_mul = 0.5,
		inner_rect = 16
	},
	destiny2_handcannon = {
		name = "Hand Cannon (Destiny 2)",
		parts = {
			{
				texture_path = "assets/destiny2_handcannon",
				w = 24,
				h = 24
			}
		}
	},
	destiny2_autorifle = {
		name = "Auto Rifle (Destiny 2)",
		bloom_func = function(index,bitmap,data)
			local crosshair_data = data.crosshair_data
			local part_data = crosshair_data.parts[index]
			local bloom = data.bloom * (crosshair_data.bloom_mul or 1)
			local scale = (data.scale or 1) * (part_data.scale or 1)
			if index > 4 then 
				local angle = part_data.angle or 0
				local distance = scale * (part_data.distance) * (bloom + 1)
				local inner_rect = bitmap:texture_width() - ((1 - bloom) * crosshair_data.inner_rect)
				bitmap:set_image(part_data.texture,0,0,inner_rect,inner_rect)
				local c_x = data.panel_w/2
				local c_y = data.panel_h/2
				bitmap:set_alpha(bloom + part_data.alpha)
				bitmap:set_center(c_x + (math.sin(angle) * distance),c_y - (math.cos(angle) * distance))
			end
		end,
		parts = {
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 90,
				angle = 0,
				distance = 16,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 180,
				angle = 90,
				distance = 16,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 270,
				angle = 180,
				distance = 16,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 0,
				angle = 270,
				distance = 16,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 12,
				h = 12,
				rotation = 0,
				angle = 315,
				distance = 12,
				alpha = 0.25
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 12,
				h = 12,
				rotation = 90,
				angle = 45,
				distance = 12,
				alpha = 0.25
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 12,
				h = 12,
				rotation = 180,
				angle = 135,
				distance = 12,
				alpha = 0.25
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 12,
				h = 12,
				rotation = 270,
				angle = 225,
				distance = 12,
				alpha = 0.25
			}
		},
		inner_rect = 12
	},
	destiny2_sidearm = {
		name = "Sidearm (Destiny 2)",
		bloom_func = function(index,bitmap,data)
			local crosshair_data = data.crosshair_data
			local part_data = crosshair_data.parts[index]
			local bloom = data.bloom * (crosshair_data.bloom_mul or 1)
			local scale = (data.scale or 1) * (part_data.scale or 1)
			if index > 4 then 
				local angle = part_data.angle or 0
				local distance = scale * (part_data.distance) * (bloom + 1)
				local inner_rect = bitmap:texture_width() - ((1 - bloom) * crosshair_data.inner_rect)
				bitmap:set_image(part_data.texture,0,0,inner_rect,inner_rect)
				local c_x = data.panel_w/2
				local c_y = data.panel_h/2
				bitmap:set_alpha(bloom + part_data.alpha)
				bitmap:set_center(c_x + (math.sin(angle) * distance),c_y - (math.cos(angle) * distance))
			end
		end,
		parts = {
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 90,
				angle = 0,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 180,
				angle = 90,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 270,
				angle = 180,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_1",
				w = 16,
				h = 3,
				rotation = 0,
				angle = 270,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 10,
				h = 10,
				rotation = 0,
				angle = 315,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 10,
				h = 10,
				rotation = 90,
				angle = 45,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 10,
				h = 10,
				rotation = 180,
				angle = 135,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				texture_rect = {
					0,0,32,32
				},
				w = 10,
				h = 10,
				rotation = 270,
				angle = 225,
				distance = 12,
				alpha = 1
			}
		},
		inner_rect = 10
	},
	destiny2_pulserifle = {
		name = "Pulse Rifle (Destiny 2)",
		bloom_func = function(index,bitmap,data)
			local crosshair_data = data.crosshair_data
			local part_data = crosshair_data.parts[index]
			local bloom = data.bloom * (crosshair_data.bloom_mul or 1)
			local scale = (data.scale or 1) * (part_data.scale or 1)
			if index < 5 then 
				local angle = part_data.angle or 0
				local distance = scale * (part_data.distance) * (bloom + 1)
				local c_x = data.panel_w/2
				local c_y = data.panel_h/2
				bitmap:set_alpha(bloom + part_data.alpha)
				bitmap:set_center(c_x + (math.sin(angle) * distance),c_y - (math.cos(angle) * distance))
			end
		end,
		parts = {
			{
				texture_path = "assets/destiny2_pulserifle_1",
				w = 6,
				h = 4,
				rotation = 0,
				angle = 0,
				distance = 6,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_pulserifle_1",
				w = 6,
				h = 4,
				rotation = 90,
				angle = 90,
				distance = 6,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_pulserifle_1",
				w = 6,
				h = 4,
				rotation = 180,
				angle = 180,
				distance = 6,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_pulserifle_1",
				w = 6,
				h = 4,
				rotation = 270,
				angle = 270,
				distance = 6,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 12,
				h = 12,
				rotation = 0,
				angle = 315,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 12,
				h = 12,
				rotation = 90,
				angle = 45,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 12,
				h = 12,
				rotation = 180,
				angle = 135,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 12,
				h = 12,
				rotation = 270,
				angle = 225,
				distance = 12,
				alpha = 1
			}
		},
		bloom_mul = 0.66
	},
	destiny2_submachinegun = {
		name = "Submachinegun (Destiny 2)",
		bloom_func = function(index,bitmap,data)
			local crosshair_data = data.crosshair_data
			local part_data = crosshair_data.parts[index]
			local bloom = data.bloom * (crosshair_data.bloom_mul or 1)
			local scale = (data.scale or 1) * (part_data.scale or 1)
			if index ~= 1 then 
				local angle = part_data.angle or 0
				local distance = scale * (part_data.distance) * (bloom + 1)
				local c_x = data.panel_w/2
				local c_y = data.panel_h/2
				bitmap:set_center(c_x + (math.sin(angle) * distance),c_y - (math.cos(angle) * distance))
			end
		end,
		parts = {
			{
				texture_path = "assets/destiny2_submachinegun_1",
				w = 48,
				h = 48,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 0,
				angle = 315,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 90,
				angle = 45,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 180,
				angle = 135,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 270,
				angle = 225,
				distance = 12,
				alpha = 1
			}
		}
	},
	destiny2_machinegun = {
		name = "Machinegun (Destiny 2)",
		bloom_func = function(index,bitmap,data)
			local crosshair_data = data.crosshair_data
			local part_data = crosshair_data.parts[index]
			local bloom = data.bloom * (crosshair_data.bloom_mul or 1)
			local scale = (data.scale or 1) * (part_data.scale or 1)
			if index > 4 then 
				local angle = part_data.angle or 0
				local distance = scale * (part_data.distance) * (bloom + 1)
				local c_x = data.panel_w/2
				local c_y = data.panel_h/2
				bitmap:set_center(c_x + (math.sin(angle) * distance),c_y - (math.cos(angle) * distance))
			end
		end,
		parts = {
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 16,
				h = 16,
				rotation = 45,
				angle = 0,
				distance = 24,
				alpha = 0.8
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 16,
				h = 16,
				rotation = 135,
				angle = 90,
				distance = 24,
				alpha = 0.8
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 16,
				h = 16,
				rotation = 225,
				angle = 180,
				distance = 24,
				alpha = 0.8
			},
			{
				texture_path = "assets/destiny2_autorifle_2",
				w = 16,
				h = 16,
				rotation = 315,
				angle = 270,
				distance = 24,
				alpha = 0.8
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 0,
				angle = 315,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 90,
				angle = 45,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 180,
				angle = 135,
				distance = 12,
				alpha = 1
			},
			{
				texture_path = "assets/destiny2_submachinegun_2",
				w = 12,
				h = 12,
				rotation = 270,
				angle = 225,
				distance = 12,
				alpha = 1
			}
		}
	}
}

return true,destiny_crosshairs_data